Page MenuHomePhabricator

Shot: Disable util dialog if no filemanager is enabled
Open, NormalPublic

Description

Heya! Longtime Enlightenment user here.

I may be one of the outliers that do not utilize the desktop or filemanager facilities of Enlightenment.

As of around commit dda50e8d8778762a315a556b74040c60190fda67, the shot module will display a dialog if efm or any other filemanager isn't enabled after saving a shot.

I've worked around this since January by disabling the else condition starting on line 201 in e_mod_save.c in a local working copy. I've git stashed far too many times without bringing it up here.

Is this dialog absolutely necessary? If so, would you consider providing a bool to disable it intentionally?

Thanks for your time and effort.

morb created this task.Sep 21 2020, 5:14 PM
morb added a comment.Oct 7 2020, 3:31 PM

pardon, this was added at commit f32ac2d1a9f0.

ProhtMeyhet triaged this task as Normal priority.Oct 8 2020, 8:06 AM
raster added a comment.Oct 9 2020, 3:28 AM

Well it's not a dialog so much as showing you the screenshot where it was saved. As such - e has the ability to do that and so it does. As the shots are in a dot directory (~/.e/...) if e didn't show this you'd have no idea what happened - did it save? did it not? where did it save? You can just close the window, but it pops up for you to then USE the file as you saved it - the obvious next step is that you want to USE it. e.,g. open it it in gimp. dnd it onto an email to attach it or something... as E comes with its own file manager ... this is the obvious thing to do. EFM is literally part of e - it isn't a separate process or tool or package. the fileman module doesn't hold the file manager.. it just holds code to take existing filemanager code already in e and put it into a window of its own and place that file manager object e already has on your desktop bg etc.

so that being said - if you disabled the fileman module, you disabled the code to do the above - well disabled a special entry point. if someone saves a shot and has no response... how do they know that disabling that is the cause of them having no idea where their screenshots go? so now to the option. where do i put that? where do i store it? shot has no config saved. i have to add a whole config implementation for shot just for this single boolean - let's assume i added it as a checkbox to that dialog with "don't bother me again"... i probably need some way to unset that option so i need to add a config dialog for shot for a single checkbox. that doesn't justify it. i can add it to the shot window along with quality etc. - but that's clutter there and the tools already force the window to be rather large. so back to the config dialog. i have to register a settings entry, put in a chunk of code to spawn a config dialog from the main settings panel (you register a named settings entry with a function to call to bring it up). the code to show the dialog, fill it with a single checkbox. for the option to turn off an error dialog... that doesn't make sense. it's a lot of code and work for a very niche thing.

the other option is to remove the error dialog. that is the only sane option here IMHO and ... that comes with the "now people who disabled efm just have shots saved and they never have any idea where or even if it succeeded". the sane option then is to have this dialog just tell you where it saved it to so you know it worked and where it put it.. so you're back to having a dialog anyway... :)

the issue here is going from zero config to just one value is a large step. once made it's easy to add things, but here it's not justifying the leap to that IMHO.

Now, if the user had a Choice of where to put That image, or Upload onto E org.....

"I've worked around this since January by disabling the else condition starting on line 201 in e_mod_save.c in a local working copy. I've git stashed far too many times without bringing it up here.

Is this dialog absolutely necessary? If so, would you consider providing a bool to disable it intentionally?"

I'd like to see your idea for the fix first.....

If you make a patch for this, I Will Happily Look over it. Love to see this Fixed.......

"the other option is to remove the error dialog. that is the only sane option here IMHO and ... that comes with the "now people who disabled efm just have shots saved and they never have any idea where or even if it succeeded". the sane option then is to have this dialog just tell you where it saved it to so you know it worked and where it put it.. so you're back to having a dialog anyway... :)"

Give it a timeout so that you can go "Ok, That's where the Shot Is"....

Now there is something to read ^^^

I'll still look at the patch tho....

dh

@devilhorns i had long debates about people complaining "its so much more work" over a single click ... e.g. having to hit save then click something then ctrl+c ... like a long debate. so the "it gets dropped into this dir always and you get shown it to then do what u want with it" is avoiding extra clicks to keep them happy. you'd be amazed... :) but adding config to where to save is possible - but again... really is it necessary?

my point is e is MEANT to be used with efm. that is the intent. if someone wants to go avoid it they are going against the intended use and work flow. if efm doesn't have some feature and t hey avoid it and use another fm instead .. well then they take on some extra burden/work in other areas. it'll get worse over time. i always intended efm and e to be tightly integrated and piggy-back on each-other. the only reason ibar itself is not an efm file view is just i wrote ibar before i had efm... efm has not been used enough in e - many config dialogs that select something should really just be displaying the content of some dir... and more.

if people want features they miss in efm.. patches accepted. but every hoop we add to jump through to avoid efm goes against the vision that e comes with a file manager (this is what amiga workbench was and frankly that's kind of a core background/vision for enlightenment as i came from the amiga world) is just retarding efm's use, features etc. and just strategically i'm not that into the idea of helping to avoid efm. strategically i'd rather push people to it and in the process give rise to "well damn-it ... if i'm going to use this file manager and all it needed was this feature to make me happy, i'll go make it do that and send a patch".

i do intend a major rewrite of efm - it's in the todo list, but for now i am focusing on other things like the flat theme, but i'd like to throw this encouragement in - adding features that are workarounds someone not wanting efm is work against the design goals of e. the more work involved, the less of a good thing it is. :)